/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parserparse
#define yylex           parserlex
#define yyerror         parsererror
#define yydebug         parserdebug
#define yynerrs         parsernerrs
#define yylval          parserlval
#define yychar          parserchar
#define yylloc          parserlloc

/* First part of user prologue.  */
#line 29 "src/core/parser.y"


#include <sys/types.h>
#include <sys/stat.h>
#ifdef _MSC_VER
#define strdup _strdup
#else
#include <unistd.h>
#endif

#include "core/SourceFile.h"
#include "core/UserModule.h"
#include "core/ModuleInstantiation.h"
#include "core/Assignment.h"
#include "core/Expression.h"
#include "core/function.h"
#include "io/fileutils.h"
#include "utils/printutils.h"
#include <memory>
#include <sstream>
#include <stack>
#include <filesystem>

namespace fs = std::filesystem;

#define YYMAXDEPTH 20000
#define LOC(loc) Location(loc.first_line, loc.first_column, loc.last_line, loc.last_column, sourcefile())
#ifdef DEBUG
static Location debug_location(const std::string& info, const struct YYLTYPE& loc);
#define LOCD(str, loc) debug_location(str, loc)
#else
#define LOCD(str, loc) LOC(loc)
#endif

int parser_error_pos = -1;

int parserlex(void);
void yyerror(char const *s);

int lexerget_lineno(void);
bool lexer_is_main_file();
std::shared_ptr<fs::path> sourcefile(void);
void lexer_set_parser_sourcefile(const fs::path& path);
int lexerlex_destroy(void);
int lexerlex(void);
static void handle_assignment(const std::string token, Expression *expr, const Location loc);

std::stack<LocalScope *> scope_stack;
SourceFile *rootfile;

extern void lexerdestroy();
extern FILE *lexerin;
const char *parser_input_buffer;
static fs::path mainFilePath;
static bool parsingMainFile;

bool fileEnded=false;

#line 138 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.hxx"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_ERROR = 3,                  /* TOK_ERROR  */
  YYSYMBOL_TOK_EOT = 4,                    /* TOK_EOT  */
  YYSYMBOL_TOK_MODULE = 5,                 /* TOK_MODULE  */
  YYSYMBOL_TOK_FUNCTION = 6,               /* TOK_FUNCTION  */
  YYSYMBOL_TOK_IF = 7,                     /* TOK_IF  */
  YYSYMBOL_TOK_ELSE = 8,                   /* TOK_ELSE  */
  YYSYMBOL_TOK_FOR = 9,                    /* TOK_FOR  */
  YYSYMBOL_TOK_LET = 10,                   /* TOK_LET  */
  YYSYMBOL_TOK_ASSERT = 11,                /* TOK_ASSERT  */
  YYSYMBOL_TOK_ECHO = 12,                  /* TOK_ECHO  */
  YYSYMBOL_TOK_EACH = 13,                  /* TOK_EACH  */
  YYSYMBOL_TOK_ID = 14,                    /* TOK_ID  */
  YYSYMBOL_TOK_STRING = 15,                /* TOK_STRING  */
  YYSYMBOL_TOK_USE = 16,                   /* TOK_USE  */
  YYSYMBOL_TOK_NUMBER = 17,                /* TOK_NUMBER  */
  YYSYMBOL_TOK_TRUE = 18,                  /* TOK_TRUE  */
  YYSYMBOL_TOK_FALSE = 19,                 /* TOK_FALSE  */
  YYSYMBOL_TOK_UNDEF = 20,                 /* TOK_UNDEF  */
  YYSYMBOL_LE = 21,                        /* LE  */
  YYSYMBOL_GE = 22,                        /* GE  */
  YYSYMBOL_EQ = 23,                        /* EQ  */
  YYSYMBOL_NEQ = 24,                       /* NEQ  */
  YYSYMBOL_AND = 25,                       /* AND  */
  YYSYMBOL_OR = 26,                        /* OR  */
  YYSYMBOL_NO_ELSE = 27,                   /* NO_ELSE  */
  YYSYMBOL_28_ = 28,                       /* ';'  */
  YYSYMBOL_29_ = 29,                       /* '{'  */
  YYSYMBOL_30_ = 30,                       /* '}'  */
  YYSYMBOL_31_ = 31,                       /* '('  */
  YYSYMBOL_32_ = 32,                       /* ')'  */
  YYSYMBOL_33_ = 33,                       /* '='  */
  YYSYMBOL_34_ = 34,                       /* '!'  */
  YYSYMBOL_35_ = 35,                       /* '#'  */
  YYSYMBOL_36_ = 36,                       /* '%'  */
  YYSYMBOL_37_ = 37,                       /* '*'  */
  YYSYMBOL_38_ = 38,                       /* '?'  */
  YYSYMBOL_39_ = 39,                       /* ':'  */
  YYSYMBOL_40_ = 40,                       /* '>'  */
  YYSYMBOL_41_ = 41,                       /* '<'  */
  YYSYMBOL_42_ = 42,                       /* '+'  */
  YYSYMBOL_43_ = 43,                       /* '-'  */
  YYSYMBOL_44_ = 44,                       /* '/'  */
  YYSYMBOL_45_ = 45,                       /* '^'  */
  YYSYMBOL_46_ = 46,                       /* '['  */
  YYSYMBOL_47_ = 47,                       /* ']'  */
  YYSYMBOL_48_ = 48,                       /* '.'  */
  YYSYMBOL_49_ = 49,                       /* ','  */
  YYSYMBOL_YYACCEPT = 50,                  /* $accept  */
  YYSYMBOL_input = 51,                     /* input  */
  YYSYMBOL_statement = 52,                 /* statement  */
  YYSYMBOL_53_1 = 53,                      /* $@1  */
  YYSYMBOL_inner_input = 54,               /* inner_input  */
  YYSYMBOL_assignment = 55,                /* assignment  */
  YYSYMBOL_module_instantiation = 56,      /* module_instantiation  */
  YYSYMBOL_57_2 = 57,                      /* @2  */
  YYSYMBOL_ifelse_statement = 58,          /* ifelse_statement  */
  YYSYMBOL_59_3 = 59,                      /* $@3  */
  YYSYMBOL_if_statement = 60,              /* if_statement  */
  YYSYMBOL_61_4 = 61,                      /* @4  */
  YYSYMBOL_child_statements = 62,          /* child_statements  */
  YYSYMBOL_child_statement = 63,           /* child_statement  */
  YYSYMBOL_module_id = 64,                 /* module_id  */
  YYSYMBOL_single_module_instantiation = 65, /* single_module_instantiation  */
  YYSYMBOL_expr = 66,                      /* expr  */
  YYSYMBOL_logic_or = 67,                  /* logic_or  */
  YYSYMBOL_logic_and = 68,                 /* logic_and  */
  YYSYMBOL_equality = 69,                  /* equality  */
  YYSYMBOL_comparison = 70,                /* comparison  */
  YYSYMBOL_addition = 71,                  /* addition  */
  YYSYMBOL_multiplication = 72,            /* multiplication  */
  YYSYMBOL_unary = 73,                     /* unary  */
  YYSYMBOL_exponent = 74,                  /* exponent  */
  YYSYMBOL_call = 75,                      /* call  */
  YYSYMBOL_primary = 76,                   /* primary  */
  YYSYMBOL_expr_or_empty = 77,             /* expr_or_empty  */
  YYSYMBOL_list_comprehension_elements = 78, /* list_comprehension_elements  */
  YYSYMBOL_list_comprehension_elements_p = 79, /* list_comprehension_elements_p  */
  YYSYMBOL_optional_trailing_comma = 80,   /* optional_trailing_comma  */
  YYSYMBOL_vector_elements = 81,           /* vector_elements  */
  YYSYMBOL_vector_element = 82,            /* vector_element  */
  YYSYMBOL_parameters = 83,                /* parameters  */
  YYSYMBOL_parameter_list = 84,            /* parameter_list  */
  YYSYMBOL_parameter = 85,                 /* parameter  */
  YYSYMBOL_arguments = 86,                 /* arguments  */
  YYSYMBOL_argument_list = 87,             /* argument_list  */
  YYSYMBOL_argument = 88                   /* argument  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   448

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  50
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  39
/* YYNRULES -- Number of rules.  */
#define YYNRULES  114
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  220

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   282


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    34,     2,    35,     2,    36,     2,     2,
      31,    32,    37,    42,    49,    43,    48,    44,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    39,    28,
      41,    33,    40,    38,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    46,     2,    47,    45,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    29,     2,    30,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   172,   172,   173,   179,   183,   184,   185,   189,   191,
     190,   204,   212,   219,   220,   224,   232,   237,   242,   247,
     253,   252,   262,   269,   274,   273,   286,   285,   298,   299,
     300,   304,   305,   306,   314,   315,   316,   317,   318,   319,
     323,   332,   333,   338,   342,   347,   352,   360,   361,   368,
     369,   376,   377,   381,   388,   389,   393,   397,   401,   408,
     409,   413,   420,   421,   425,   429,   437,   438,   442,   453,
     460,   461,   468,   469,   474,   478,   486,   490,   494,   498,
     502,   507,   512,   516,   520,   524,   528,   536,   539,   548,
     553,   557,   562,   568,   572,   580,   581,   588,   589,   593,
     598,   606,   607,   612,   615,   619,   624,   632,   637,   646,
     649,   653,   658,   666,   670
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_ERROR", "TOK_EOT",
  "TOK_MODULE", "TOK_FUNCTION", "TOK_IF", "TOK_ELSE", "TOK_FOR", "TOK_LET",
  "TOK_ASSERT", "TOK_ECHO", "TOK_EACH", "TOK_ID", "TOK_STRING", "TOK_USE",
  "TOK_NUMBER", "TOK_TRUE", "TOK_FALSE", "TOK_UNDEF", "LE", "GE", "EQ",
  "NEQ", "AND", "OR", "NO_ELSE", "';'", "'{'", "'}'", "'('", "')'", "'='",
  "'!'", "'#'", "'%'", "'*'", "'?'", "':'", "'>'", "'<'", "'+'", "'-'",
  "'/'", "'^'", "'['", "']'", "'.'", "','", "$accept", "input",
  "statement", "$@1", "inner_input", "assignment", "module_instantiation",
  "@2", "ifelse_statement", "$@3", "if_statement", "@4",
  "child_statements", "child_statement", "module_id",
  "single_module_instantiation", "expr", "logic_or", "logic_and",
  "equality", "comparison", "addition", "multiplication", "unary",
  "exponent", "call", "primary", "expr_or_empty",
  "list_comprehension_elements", "list_comprehension_elements_p",
  "optional_trailing_comma", "vector_elements", "vector_element",
  "parameters", "parameter_list", "parameter", "arguments",
  "argument_list", "argument", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-87)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -87,   323,   -87,   -87,    -1,     8,     9,   -87,   -87,   -87,
     -87,   -87,    18,   -87,   -87,   -87,   411,   411,   411,   411,
     -87,   -87,   -87,   -87,    40,    27,   -87,    34,    36,   123,
     123,   336,   -87,   -87,   -87,   -87,   -87,   -87,   279,   380,
      61,    61,    54,    60,    65,    72,   -87,   -87,   -87,   -87,
     -87,   -87,   123,    11,    11,    11,   181,    69,   -14,    67,
      32,    -7,    21,     2,   -87,   -87,     4,   -87,    80,   -87,
     -87,   380,    76,   -87,    78,    62,   -87,   -87,   -87,   -87,
     -87,    82,    81,    68,   -87,    88,    61,   279,   279,   279,
      89,   -87,   -87,   -87,    91,    92,    93,   223,   261,   -87,
      86,   -87,   -87,    77,   -87,   -87,    11,   123,    11,    11,
      11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
     279,    11,   123,   114,   -87,   -87,   123,   -87,   279,   -87,
      70,   123,   -87,    61,   -87,    97,   104,   107,   112,   113,
     -87,   123,   279,   279,   -87,   -87,   121,   123,   223,    99,
     380,    67,   116,    32,    -7,    -7,    21,    21,    21,    21,
       2,     2,   -87,   -87,   -87,   124,   -87,   111,   -87,   -87,
     -87,   -87,   -87,   -87,   -87,   370,   -87,   123,   123,   123,
     123,   123,   127,    15,   128,   -87,    -3,   -87,   -87,   -87,
     123,   -87,   -87,   -87,   134,   -87,   -87,   -87,   -87,   -87,
     223,   123,   223,   223,   123,   -87,   -87,   -87,   155,   136,
     -87,   -87,   120,   223,   279,   -87,   -87,   138,   223,   -87
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     1,    12,     0,     0,     0,    35,    36,    37,
      38,    39,    34,     3,     5,    13,     0,     0,     0,     0,
       4,     8,     7,    22,    23,     0,    20,     0,     0,     0,
       0,     0,    34,    16,    17,    18,    19,    24,   109,     0,
     103,   103,     0,     0,     0,     0,    81,    80,    79,    76,
      77,    78,     0,     0,     0,     0,     0,     0,    41,    47,
      49,    51,    54,    59,    62,    66,    70,    72,     0,     6,
      14,     0,    81,   113,     0,    97,   111,    31,    28,    33,
      21,   107,     0,    97,   105,     0,   103,   109,   109,   109,
       0,    69,    67,    68,     0,     0,     0,     0,     0,    85,
     102,    95,   101,    97,    99,    26,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     109,     0,     0,     0,    15,    25,     0,    40,    98,   110,
       0,     0,     9,    98,   104,     0,     0,     0,     0,     0,
      82,     0,   109,   109,   102,    90,     0,     0,    98,     0,
       0,    48,     0,    50,    52,    53,    58,    56,    55,    57,
      60,    61,    65,    63,    64,     0,    71,     0,    75,   114,
     112,    32,    30,    29,   108,     0,   106,     0,     0,     0,
      87,    87,     0,     0,     0,    96,     0,   100,    86,    27,
       0,    73,    74,    10,     0,    42,    44,    88,    45,    46,
       0,     0,     0,     0,     0,    83,    43,    11,    93,     0,
      91,    89,     0,     0,   109,    84,    94,     0,     0,    92
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -87,   -87,   -28,   -87,   -87,    38,     1,   -87,   -87,   -87,
     -87,   -87,   -87,   -64,   -87,   -87,   -29,   -87,    71,    73,
     -39,   -24,   -21,   -45,   -87,   -87,   -87,    -2,    84,   -23,
     -62,   -87,   -86,   -25,   -87,    45,   -83,   -87,    55
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     1,    20,   175,    31,    21,    79,    39,    23,    71,
      24,   150,   130,    80,    25,    26,    73,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,   198,   101,   102,
     129,   103,   104,    82,    83,    84,    74,    75,    76
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      57,    68,    22,    70,   137,   138,   139,   125,    91,    92,
      93,   145,   106,    27,   111,   112,    85,    33,    34,    35,
      36,   134,    28,    90,   107,    46,    47,   100,    48,    49,
      50,    51,    22,   113,   114,   120,   204,   165,   117,   118,
      29,   149,    52,   201,   205,    53,   119,   202,    37,   121,
     122,    30,   123,    54,    55,   109,   110,    56,    38,   183,
     184,   136,   187,   115,   116,    40,   173,    41,   144,    90,
     154,   155,   162,   163,   164,    81,   166,     6,   152,     7,
       8,     9,    10,    11,    12,    86,   189,   156,   157,   158,
     159,    87,   108,   167,   160,   161,    88,   169,    77,    78,
     171,   105,   174,    89,    16,    17,    18,    19,   124,   126,
     127,   128,   182,   132,   208,   131,   210,   133,   186,   144,
     135,   140,   141,   142,   143,   147,   148,   216,   168,    42,
     177,   217,   219,    43,    44,    45,   178,    46,    47,   179,
      48,    49,    50,    51,   180,   181,   188,   193,   194,   195,
     196,   197,   197,   185,    52,   190,   191,    53,   192,   200,
     203,   206,   207,   213,   214,    54,    55,   215,   172,    56,
     218,   144,   209,   144,   196,   212,    22,   151,   176,   199,
     211,   153,   146,   170,   144,     0,     0,    42,    94,   144,
      95,    96,    44,    45,    97,    46,    47,     0,    48,    49,
      50,    51,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    98,     0,     0,    53,     0,     0,     0,     0,
       0,     0,     0,    54,    55,     0,     0,    56,    99,    42,
      94,     0,    95,    96,    44,    45,    97,    46,    47,     0,
      48,    49,    50,    51,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    98,     0,     0,    53,     0,     0,
       0,     0,     0,     0,     0,    54,    55,    42,    94,    56,
      95,    96,    44,    45,    97,    46,    47,     0,    48,    49,
      50,    51,     0,     0,     0,    42,     0,     0,     0,    43,
      44,    45,    52,    72,    47,    53,    48,    49,    50,    51,
       0,     0,     0,    54,    55,     0,     0,    56,     0,     0,
      52,     0,     0,    53,     0,     0,     0,     0,     0,     0,
       0,    54,    55,     2,     0,    56,     0,     3,     4,     5,
       6,     0,     7,     8,     9,    10,    11,    12,     0,    13,
       3,     4,     5,     6,     0,     7,     8,     9,    10,    11,
      12,    14,    15,     0,     0,     0,     0,    16,    17,    18,
      19,     0,     0,     0,    14,    15,    69,     0,     0,     0,
      16,    17,    18,    19,     3,     4,     5,     6,     0,     7,
       8,     9,    10,    11,    12,     0,     0,     6,     0,     7,
       8,     9,    10,    11,    32,     0,     0,     0,    14,    15,
       0,     0,     0,     0,    16,    17,    18,    19,    77,    78,
       0,     0,     0,     0,    16,    17,    18,    19,     6,     0,
       7,     8,     9,    10,    11,    32,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,    18,    19
};

static const yytype_int16 yycheck[] =
{
      29,    30,     1,    31,    87,    88,    89,    71,    53,    54,
      55,    97,    26,    14,    21,    22,    41,    16,    17,    18,
      19,    83,    14,    52,    38,    14,    15,    56,    17,    18,
      19,    20,    31,    40,    41,    31,    39,   120,    36,    37,
      31,   103,    31,    28,    47,    34,    44,    32,     8,    45,
      46,    33,    48,    42,    43,    23,    24,    46,    31,   142,
     143,    86,   148,    42,    43,    31,   130,    31,    97,    98,
     109,   110,   117,   118,   119,    14,   121,     7,   107,     9,
      10,    11,    12,    13,    14,    31,   150,   111,   112,   113,
     114,    31,    25,   122,   115,   116,    31,   126,    28,    29,
      30,    32,   131,    31,    34,    35,    36,    37,    28,    33,
      32,    49,   141,    32,   200,    33,   202,    49,   147,   148,
      32,    32,    31,    31,    31,    39,    49,   213,    14,     6,
      33,   214,   218,    10,    11,    12,    32,    14,    15,    32,
      17,    18,    19,    20,    32,    32,    47,   175,   177,   178,
     179,   180,   181,    32,    31,    39,    32,    34,    47,    32,
      32,   190,    28,     8,    28,    42,    43,    47,   130,    46,
      32,   200,   201,   202,   203,   204,   175,   106,   133,   181,
     203,   108,    98,   128,   213,    -1,    -1,     6,     7,   218,
       9,    10,    11,    12,    13,    14,    15,    -1,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    31,    -1,    -1,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    47,     6,
       7,    -1,     9,    10,    11,    12,    13,    14,    15,    -1,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    31,    -1,    -1,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,     6,     7,    46,
       9,    10,    11,    12,    13,    14,    15,    -1,    17,    18,
      19,    20,    -1,    -1,    -1,     6,    -1,    -1,    -1,    10,
      11,    12,    31,    14,    15,    34,    17,    18,    19,    20,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,
      31,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,     0,    -1,    46,    -1,     4,     5,     6,
       7,    -1,     9,    10,    11,    12,    13,    14,    -1,    16,
       4,     5,     6,     7,    -1,     9,    10,    11,    12,    13,
      14,    28,    29,    -1,    -1,    -1,    -1,    34,    35,    36,
      37,    -1,    -1,    -1,    28,    29,    30,    -1,    -1,    -1,
      34,    35,    36,    37,     4,     5,     6,     7,    -1,     9,
      10,    11,    12,    13,    14,    -1,    -1,     7,    -1,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    28,    29,
      -1,    -1,    -1,    -1,    34,    35,    36,    37,    28,    29,
      -1,    -1,    -1,    -1,    34,    35,    36,    37,     7,    -1,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    35,    36,    37
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    51,     0,     4,     5,     6,     7,     9,    10,    11,
      12,    13,    14,    16,    28,    29,    34,    35,    36,    37,
      52,    55,    56,    58,    60,    64,    65,    14,    14,    31,
      33,    54,    14,    56,    56,    56,    56,     8,    31,    57,
      31,    31,     6,    10,    11,    12,    14,    15,    17,    18,
      19,    20,    31,    34,    42,    43,    46,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    66,    30,
      52,    59,    14,    66,    86,    87,    88,    28,    29,    56,
      63,    14,    83,    84,    85,    83,    31,    31,    31,    31,
      66,    73,    73,    73,     7,     9,    10,    13,    31,    47,
      66,    78,    79,    81,    82,    32,    26,    38,    25,    23,
      24,    21,    22,    40,    41,    42,    43,    36,    37,    44,
      31,    45,    46,    48,    28,    63,    33,    32,    49,    80,
      62,    33,    32,    49,    80,    32,    83,    86,    86,    86,
      32,    31,    31,    31,    66,    82,    78,    39,    49,    80,
      61,    68,    66,    69,    70,    70,    71,    71,    71,    71,
      72,    72,    73,    73,    73,    86,    73,    66,    14,    66,
      88,    30,    55,    63,    66,    53,    85,    33,    32,    32,
      32,    32,    66,    86,    86,    32,    66,    82,    47,    63,
      39,    32,    47,    52,    66,    66,    66,    66,    77,    77,
      32,    28,    32,    32,    39,    47,    66,    28,    82,    66,
      82,    79,    66,     8,    28,    47,    82,    86,    32,    82
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    50,    51,    51,    51,    52,    52,    52,    52,    53,
      52,    52,    52,    54,    54,    55,    56,    56,    56,    56,
      57,    56,    56,    58,    59,    58,    61,    60,    62,    62,
      62,    63,    63,    63,    64,    64,    64,    64,    64,    64,
      65,    66,    66,    66,    66,    66,    66,    67,    67,    68,
      68,    69,    69,    69,    70,    70,    70,    70,    70,    71,
      71,    71,    72,    72,    72,    72,    73,    73,    73,    73,
      74,    74,    75,    75,    75,    75,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    77,    77,    78,
      78,    78,    78,    78,    78,    79,    79,    80,    80,    81,
      81,    82,    82,    83,    83,    84,    84,    85,    85,    86,
      86,    87,    87,    88,    88
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     1,     3,     1,     1,     0,
       7,     8,     1,     0,     2,     4,     2,     2,     2,     2,
       0,     3,     1,     1,     0,     4,     0,     6,     0,     2,
       2,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       4,     1,     5,     5,     5,     5,     5,     1,     3,     1,
       3,     1,     3,     3,     1,     3,     3,     3,     3,     1,
       3,     3,     1,     3,     3,     3,     1,     2,     2,     2,
       1,     3,     1,     4,     4,     3,     1,     1,     1,     1,
       1,     1,     3,     5,     7,     2,     4,     0,     1,     5,
       2,     5,     9,     5,     7,     1,     3,     0,     1,     1,
       3,     1,     1,     0,     2,     1,     3,     1,     3,     0,
       2,     1,     3,     1,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */


/* User initialization code.  */
#line 89 "src/core/parser.y"
{
  yylloc.first_line = 1;
  yylloc.first_column = 1;
  yylloc.last_column = 1;
  yylloc.last_line = 1;
}

#line 1322 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* input: input TOK_USE  */
#line 175 "src/core/parser.y"
            {
              rootfile->registerUse(std::string((yyvsp[0].text)), lexer_is_main_file() && parsingMainFile ? LOC((yylsp[0])) : Location::NONE);
              free((yyvsp[0].text));
            }
#line 1538 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 7: /* statement: module_instantiation  */
#line 186 "src/core/parser.y"
            {
              if ((yyvsp[0].inst)) scope_stack.top()->addModuleInst(std::shared_ptr<ModuleInstantiation>((yyvsp[0].inst)));
            }
#line 1546 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 9: /* $@1: %empty  */
#line 191 "src/core/parser.y"
            {
              UserModule *newmodule = new UserModule((yyvsp[-3].text), LOCD("module", (yyloc)));
              newmodule->parameters = *(yyvsp[-1].args);
              auto top = scope_stack.top();
              scope_stack.push(&newmodule->body);
              top->addModule(std::shared_ptr<UserModule>(newmodule));
              free((yyvsp[-3].text));
              delete (yyvsp[-1].args);
            }
#line 1560 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 10: /* statement: TOK_MODULE TOK_ID '(' parameters ')' $@1 statement  */
#line 201 "src/core/parser.y"
            {
                scope_stack.pop();
            }
#line 1568 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 11: /* statement: TOK_FUNCTION TOK_ID '(' parameters ')' '=' expr ';'  */
#line 205 "src/core/parser.y"
            {
              scope_stack.top()->addFunction(
                std::make_shared<UserFunction>((yyvsp[-6].text), *(yyvsp[-4].args), std::shared_ptr<Expression>((yyvsp[-1].expr)), LOCD("function", (yyloc)))
              );
              free((yyvsp[-6].text));
              delete (yyvsp[-4].args);
            }
#line 1580 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 12: /* statement: TOK_EOT  */
#line 213 "src/core/parser.y"
            {
                fileEnded=true;
            }
#line 1588 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 15: /* assignment: TOK_ID '=' expr ';'  */
#line 225 "src/core/parser.y"
            {
                handle_assignment((yyvsp[-3].text), (yyvsp[-1].expr), LOCD("assignment", (yyloc)));
                free((yyvsp[-3].text));
            }
#line 1597 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 16: /* module_instantiation: '!' module_instantiation  */
#line 233 "src/core/parser.y"
            {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_root = true;
            }
#line 1606 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 17: /* module_instantiation: '#' module_instantiation  */
#line 238 "src/core/parser.y"
            {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_highlight = true;
            }
#line 1615 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 18: /* module_instantiation: '%' module_instantiation  */
#line 243 "src/core/parser.y"
            {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_background = true;
            }
#line 1624 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 19: /* module_instantiation: '*' module_instantiation  */
#line 248 "src/core/parser.y"
            {
                delete (yyvsp[0].inst);
                (yyval.inst) = NULL;
            }
#line 1633 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 20: /* @2: %empty  */
#line 253 "src/core/parser.y"
            {
                (yyval.inst) = (yyvsp[0].inst);
                scope_stack.push(&(yyvsp[0].inst)->scope);
            }
#line 1642 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 21: /* module_instantiation: single_module_instantiation @2 child_statement  */
#line 258 "src/core/parser.y"
            {
                scope_stack.pop();
                (yyval.inst) = (yyvsp[-1].inst);
            }
#line 1651 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 22: /* module_instantiation: ifelse_statement  */
#line 263 "src/core/parser.y"
            {
                (yyval.inst) = (yyvsp[0].ifelse);
            }
#line 1659 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 23: /* ifelse_statement: if_statement  */
#line 270 "src/core/parser.y"
            {
                (yyval.ifelse) = (yyvsp[0].ifelse);
            }
#line 1667 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 24: /* $@3: %empty  */
#line 274 "src/core/parser.y"
            {
                scope_stack.push((yyvsp[-1].ifelse)->makeElseScope());
            }
#line 1675 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 25: /* ifelse_statement: if_statement TOK_ELSE $@3 child_statement  */
#line 278 "src/core/parser.y"
            {
                scope_stack.pop();
                (yyval.ifelse) = (yyvsp[-3].ifelse);
            }
#line 1684 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 26: /* @4: %empty  */
#line 286 "src/core/parser.y"
            {
                (yyval.ifelse) = new IfElseModuleInstantiation(std::shared_ptr<Expression>((yyvsp[-1].expr)), LOCD("if", (yyloc)));
                scope_stack.push(&(yyval.ifelse)->scope);
            }
#line 1693 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 27: /* if_statement: TOK_IF '(' expr ')' @4 child_statement  */
#line 291 "src/core/parser.y"
            {
                scope_stack.pop();
                (yyval.ifelse) = (yyvsp[-1].ifelse);
            }
#line 1702 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 33: /* child_statement: module_instantiation  */
#line 307 "src/core/parser.y"
            {
                if ((yyvsp[0].inst)) scope_stack.top()->addModuleInst(std::shared_ptr<ModuleInstantiation>((yyvsp[0].inst)));
            }
#line 1710 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 34: /* module_id: TOK_ID  */
#line 314 "src/core/parser.y"
                  { (yyval.text) = (yyvsp[0].text); }
#line 1716 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 35: /* module_id: TOK_FOR  */
#line 315 "src/core/parser.y"
                  { (yyval.text) = strdup("for"); }
#line 1722 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 36: /* module_id: TOK_LET  */
#line 316 "src/core/parser.y"
                  { (yyval.text) = strdup("let"); }
#line 1728 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 37: /* module_id: TOK_ASSERT  */
#line 317 "src/core/parser.y"
                     { (yyval.text) = strdup("assert"); }
#line 1734 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 38: /* module_id: TOK_ECHO  */
#line 318 "src/core/parser.y"
                   { (yyval.text) = strdup("echo"); }
#line 1740 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 39: /* module_id: TOK_EACH  */
#line 319 "src/core/parser.y"
                   { (yyval.text) = strdup("each"); }
#line 1746 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 40: /* single_module_instantiation: module_id '(' arguments ')'  */
#line 324 "src/core/parser.y"
            {
                (yyval.inst) = new ModuleInstantiation((yyvsp[-3].text), *(yyvsp[-1].args), LOCD("modulecall", (yyloc)));
                free((yyvsp[-3].text));
                delete (yyvsp[-1].args);
            }
#line 1756 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 42: /* expr: TOK_FUNCTION '(' parameters ')' expr  */
#line 334 "src/core/parser.y"
            {
              (yyval.expr) = new FunctionDefinition((yyvsp[0].expr), *(yyvsp[-2].args), LOCD("anonfunc", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 1765 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 43: /* expr: logic_or '?' expr ':' expr  */
#line 339 "src/core/parser.y"
            {
              (yyval.expr) = new TernaryOp((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), LOCD("ternary", (yyloc)));
            }
#line 1773 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 44: /* expr: TOK_LET '(' arguments ')' expr  */
#line 343 "src/core/parser.y"
            {
              (yyval.expr) = FunctionCall::create("let", *(yyvsp[-2].args), (yyvsp[0].expr), LOCD("let", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 1782 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 45: /* expr: TOK_ASSERT '(' arguments ')' expr_or_empty  */
#line 348 "src/core/parser.y"
            {
              (yyval.expr) = FunctionCall::create("assert", *(yyvsp[-2].args), (yyvsp[0].expr), LOCD("assert", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 1791 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 46: /* expr: TOK_ECHO '(' arguments ')' expr_or_empty  */
#line 353 "src/core/parser.y"
            {
              (yyval.expr) = FunctionCall::create("echo", *(yyvsp[-2].args), (yyvsp[0].expr), LOCD("echo", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 1800 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 48: /* logic_or: logic_or OR logic_and  */
#line 362 "src/core/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::LogicalOr, (yyvsp[0].expr), LOCD("or", (yyloc)));
            }
#line 1808 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 50: /* logic_and: logic_and AND equality  */
#line 370 "src/core/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::LogicalAnd, (yyvsp[0].expr), LOCD("and", (yyloc)));
            }
#line 1816 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 52: /* equality: equality EQ comparison  */
#line 378 "src/core/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Equal, (yyvsp[0].expr), LOCD("equal", (yyloc)));
            }
#line 1824 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 53: /* equality: equality NEQ comparison  */
#line 382 "src/core/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::NotEqual, (yyvsp[0].expr), LOCD("notequal", (yyloc)));
            }
#line 1832 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 55: /* comparison: comparison '>' addition  */
#line 390 "src/core/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Greater, (yyvsp[0].expr), LOCD("greater", (yyloc)));
            }
#line 1840 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 56: /* comparison: comparison GE addition  */
#line 394 "src/core/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::GreaterEqual, (yyvsp[0].expr), LOCD("greaterequal", (yyloc)));
            }
#line 1848 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 57: /* comparison: comparison '<' addition  */
#line 398 "src/core/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Less, (yyvsp[0].expr), LOCD("less", (yyloc)));
            }
#line 1856 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 58: /* comparison: comparison LE addition  */
#line 402 "src/core/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::LessEqual, (yyvsp[0].expr), LOCD("lessequal", (yyloc)));
            }
#line 1864 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 60: /* addition: addition '+' multiplication  */
#line 410 "src/core/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Plus, (yyvsp[0].expr), LOCD("addition", (yyloc)));
            }
#line 1872 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 61: /* addition: addition '-' multiplication  */
#line 414 "src/core/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Minus, (yyvsp[0].expr), LOCD("subtraction", (yyloc)));
            }
#line 1880 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 63: /* multiplication: multiplication '*' unary  */
#line 422 "src/core/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Multiply, (yyvsp[0].expr), LOCD("multiply", (yyloc)));
            }
#line 1888 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 64: /* multiplication: multiplication '/' unary  */
#line 426 "src/core/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Divide, (yyvsp[0].expr), LOCD("divide", (yyloc)));
            }
#line 1896 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 65: /* multiplication: multiplication '%' unary  */
#line 430 "src/core/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Modulo, (yyvsp[0].expr), LOCD("modulo", (yyloc)));
            }
#line 1904 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 67: /* unary: '+' unary  */
#line 439 "src/core/parser.y"
            {
                (yyval.expr) = (yyvsp[0].expr);
            }
#line 1912 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 68: /* unary: '-' unary  */
#line 443 "src/core/parser.y"
            {
              Literal* argument = dynamic_cast<Literal*>((yyvsp[0].expr));
              if (argument && argument->isDouble()) {
                double value = argument->toDouble();
                delete (yyvsp[0].expr);
                (yyval.expr) = new Literal(-value, LOCD("literal", (yyloc)));
              } else {
                (yyval.expr) = new UnaryOp(UnaryOp::Op::Negate, (yyvsp[0].expr), LOCD("negate", (yyloc)));
              }
            }
#line 1927 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 69: /* unary: '!' unary  */
#line 454 "src/core/parser.y"
            {
              (yyval.expr) = new UnaryOp(UnaryOp::Op::Not, (yyvsp[0].expr), LOCD("not", (yyloc)));
            }
#line 1935 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 71: /* exponent: call '^' unary  */
#line 462 "src/core/parser.y"
           {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Exponent, (yyvsp[0].expr), LOCD("exponent", (yyloc)));
           }
#line 1943 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 73: /* call: call '(' arguments ')'  */
#line 470 "src/core/parser.y"
            {
              (yyval.expr) = new FunctionCall((yyvsp[-3].expr), *(yyvsp[-1].args), LOCD("functioncall", (yyloc)));
              delete (yyvsp[-1].args);
            }
#line 1952 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 74: /* call: call '[' expr ']'  */
#line 475 "src/core/parser.y"
            {
              (yyval.expr) = new ArrayLookup((yyvsp[-3].expr), (yyvsp[-1].expr), LOCD("index", (yyloc)));
            }
#line 1960 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 75: /* call: call '.' TOK_ID  */
#line 479 "src/core/parser.y"
            {
              (yyval.expr) = new MemberLookup((yyvsp[-2].expr), (yyvsp[0].text), LOCD("member", (yyloc)));
              free((yyvsp[0].text));
            }
#line 1969 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 76: /* primary: TOK_TRUE  */
#line 487 "src/core/parser.y"
            {
              (yyval.expr) = new Literal(true, LOCD("literal", (yyloc)));
            }
#line 1977 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 77: /* primary: TOK_FALSE  */
#line 491 "src/core/parser.y"
            {
              (yyval.expr) = new Literal(false, LOCD("literal", (yyloc)));
            }
#line 1985 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 78: /* primary: TOK_UNDEF  */
#line 495 "src/core/parser.y"
            {
              (yyval.expr) = new Literal(LOCD("literal", (yyloc)));
            }
#line 1993 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 79: /* primary: TOK_NUMBER  */
#line 499 "src/core/parser.y"
            {
              (yyval.expr) = new Literal((yyvsp[0].number), LOCD("literal", (yyloc)));
            }
#line 2001 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 80: /* primary: TOK_STRING  */
#line 503 "src/core/parser.y"
            {
              (yyval.expr) = new Literal(std::string((yyvsp[0].text)), LOCD("string", (yyloc)));
              free((yyvsp[0].text));
            }
#line 2010 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 81: /* primary: TOK_ID  */
#line 508 "src/core/parser.y"
            {
              (yyval.expr) = new Lookup((yyvsp[0].text), LOCD("variable", (yyloc)));
              free((yyvsp[0].text));
            }
#line 2019 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 82: /* primary: '(' expr ')'  */
#line 513 "src/core/parser.y"
            {
              (yyval.expr) = (yyvsp[-1].expr);
            }
#line 2027 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 83: /* primary: '[' expr ':' expr ']'  */
#line 517 "src/core/parser.y"
            {
              (yyval.expr) = new Range((yyvsp[-3].expr), (yyvsp[-1].expr), LOCD("range", (yyloc)));
            }
#line 2035 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 84: /* primary: '[' expr ':' expr ':' expr ']'  */
#line 521 "src/core/parser.y"
            {
              (yyval.expr) = new Range((yyvsp[-5].expr), (yyvsp[-3].expr), (yyvsp[-1].expr), LOCD("range", (yyloc)));
            }
#line 2043 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 85: /* primary: '[' ']'  */
#line 525 "src/core/parser.y"
            {
              (yyval.expr) = new Vector(LOCD("vector", (yyloc)));
            }
#line 2051 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 86: /* primary: '[' vector_elements optional_trailing_comma ']'  */
#line 529 "src/core/parser.y"
            {
              (yyval.expr) = (yyvsp[-2].vec);
            }
#line 2059 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 87: /* expr_or_empty: %empty  */
#line 536 "src/core/parser.y"
            {
              (yyval.expr) = NULL;
            }
#line 2067 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 88: /* expr_or_empty: expr  */
#line 540 "src/core/parser.y"
            {
              (yyval.expr) = (yyvsp[0].expr);
            }
#line 2075 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 89: /* list_comprehension_elements: TOK_LET '(' arguments ')' list_comprehension_elements_p  */
#line 549 "src/core/parser.y"
            {
              (yyval.expr) = new LcLet(*(yyvsp[-2].args), (yyvsp[0].expr), LOCD("lclet", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 2084 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 90: /* list_comprehension_elements: TOK_EACH vector_element  */
#line 554 "src/core/parser.y"
            {
              (yyval.expr) = new LcEach((yyvsp[0].expr), LOCD("lceach", (yyloc)));
            }
#line 2092 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 91: /* list_comprehension_elements: TOK_FOR '(' arguments ')' vector_element  */
#line 558 "src/core/parser.y"
            {
              (yyval.expr) = new LcFor(*(yyvsp[-2].args), (yyvsp[0].expr), LOCD("lcfor", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 2101 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 92: /* list_comprehension_elements: TOK_FOR '(' arguments ';' expr ';' arguments ')' vector_element  */
#line 563 "src/core/parser.y"
            {
              (yyval.expr) = new LcForC(*(yyvsp[-6].args), *(yyvsp[-2].args), (yyvsp[-4].expr), (yyvsp[0].expr), LOCD("lcforc", (yyloc)));
              delete (yyvsp[-6].args);
              delete (yyvsp[-2].args);
            }
#line 2111 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 93: /* list_comprehension_elements: TOK_IF '(' expr ')' vector_element  */
#line 569 "src/core/parser.y"
            {
              (yyval.expr) = new LcIf((yyvsp[-2].expr), (yyvsp[0].expr), 0, LOCD("lcif", (yyloc)));
            }
#line 2119 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 94: /* list_comprehension_elements: TOK_IF '(' expr ')' vector_element TOK_ELSE vector_element  */
#line 573 "src/core/parser.y"
            {
              (yyval.expr) = new LcIf((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), LOCD("lcifelse", (yyloc)));
            }
#line 2127 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 96: /* list_comprehension_elements_p: '(' list_comprehension_elements ')'  */
#line 582 "src/core/parser.y"
            {
                (yyval.expr) = (yyvsp[-1].expr);
            }
#line 2135 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 99: /* vector_elements: vector_element  */
#line 594 "src/core/parser.y"
            {
              (yyval.vec) = new Vector(LOCD("vector", (yyloc)));
              (yyval.vec)->emplace_back((yyvsp[0].expr));
            }
#line 2144 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 100: /* vector_elements: vector_elements ',' vector_element  */
#line 599 "src/core/parser.y"
            {
              (yyval.vec) = (yyvsp[-2].vec);
              (yyval.vec)->emplace_back((yyvsp[0].expr));
            }
#line 2153 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 103: /* parameters: %empty  */
#line 612 "src/core/parser.y"
            {
                (yyval.args) = new AssignmentList();
            }
#line 2161 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 105: /* parameter_list: parameter  */
#line 620 "src/core/parser.y"
            {
                (yyval.args) = new AssignmentList();
                (yyval.args)->emplace_back((yyvsp[0].arg));
            }
#line 2170 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 106: /* parameter_list: parameter_list ',' parameter  */
#line 625 "src/core/parser.y"
            {
                (yyval.args) = (yyvsp[-2].args);
                (yyval.args)->emplace_back((yyvsp[0].arg));
            }
#line 2179 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 107: /* parameter: TOK_ID  */
#line 633 "src/core/parser.y"
            {
                (yyval.arg) = new Assignment((yyvsp[0].text), LOCD("assignment", (yyloc)));
                free((yyvsp[0].text));
            }
#line 2188 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 108: /* parameter: TOK_ID '=' expr  */
#line 638 "src/core/parser.y"
            {
              (yyval.arg) = new Assignment((yyvsp[-2].text), std::shared_ptr<Expression>((yyvsp[0].expr)), LOCD("assignment", (yyloc)));
                free((yyvsp[-2].text));
            }
#line 2197 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 109: /* arguments: %empty  */
#line 646 "src/core/parser.y"
            {
                (yyval.args) = new AssignmentList();
            }
#line 2205 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 111: /* argument_list: argument  */
#line 654 "src/core/parser.y"
            {
                (yyval.args) = new AssignmentList();
                (yyval.args)->emplace_back((yyvsp[0].arg));
            }
#line 2214 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 112: /* argument_list: argument_list ',' argument  */
#line 659 "src/core/parser.y"
            {
                (yyval.args) = (yyvsp[-2].args);
                (yyval.args)->emplace_back((yyvsp[0].arg));
            }
#line 2223 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 113: /* argument: expr  */
#line 667 "src/core/parser.y"
            {
                (yyval.arg) = new Assignment("", std::shared_ptr<Expression>((yyvsp[0].expr)), LOCD("argumentcall", (yyloc)));
            }
#line 2231 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;

  case 114: /* argument: TOK_ID '=' expr  */
#line 671 "src/core/parser.y"
            {
                (yyval.arg) = new Assignment((yyvsp[-2].text), std::shared_ptr<Expression>((yyvsp[0].expr)), LOCD("argumentcall", (yyloc)));
                free((yyvsp[-2].text));
            }
#line 2240 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"
    break;


#line 2244 "/tmp/B.jwe5of5v/BUILD/openscad-fd3a9aad2bcd913ac1830e11670f0a422231e43f/build/objects/parser.cxx"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 677 "src/core/parser.y"


int parserlex(void)
{
  return lexerlex();
}

void yyerror (char const *s)
{
  // FIXME: We leak memory on parser errors...
	Location loc = Location(lexerget_lineno(), -1, -1, -1, sourcefile());
	LOG(message_group::Error, loc, "", "Parser error: %1$s", s);
}

#ifdef DEBUG
static Location debug_location(const std::string& info, const YYLTYPE& loc)
{
	auto location = LOC(loc);
	PRINTDB("%3d, %3d - %3d, %3d | %s", loc.first_line % loc.first_column % loc.last_line % loc.last_column % info);
	return location;
}
#endif

static void warn_reassignment(const Location& loc, const std::shared_ptr<Assignment>& assignment, const fs::path& path)
{
	LOG(message_group::Warning,
			loc,
			path.parent_path().generic_string(),
			"%1$s was assigned on line %2$i but was overwritten",
			assignment->getName(),
			assignment->location().firstLine());

}

static void warn_reassignment(const Location& loc, const std::shared_ptr<Assignment>& assignment, const fs::path& path1, const fs::path& path2)
{
	LOG(message_group::Warning,
			loc,
			path1.parent_path().generic_string(),
			"%1$s was assigned on line %2$i of %3$s but was overwritten",
			assignment->getName(),
			assignment->location().firstLine(),
			path2);
}

void handle_assignment(const std::string token, Expression *expr, const Location loc)
{
	bool found = false;
	for (auto &assignment : scope_stack.top()->assignments) {
		if (assignment->getName() == token) {
			auto mainFile = mainFilePath.string();
			auto prevFile = assignment->location().fileName();
			auto currFile = loc.fileName();

			const auto uncPathCurr = fs_uncomplete(currFile, mainFilePath.parent_path());
			const auto uncPathPrev = fs_uncomplete(prevFile, mainFilePath.parent_path());
			if (fileEnded) {
				//assignments via commandline
			} else if (prevFile == mainFile && currFile == mainFile) {
				//both assignments in the mainFile
				warn_reassignment(loc, assignment, mainFilePath);
			} else if (uncPathCurr == uncPathPrev) {
				//assignment overwritten within the same file
				//the line number being equal happens, when a file is included multiple times
				if (assignment->location().firstLine() != loc.firstLine()) {
					warn_reassignment(loc, assignment, mainFilePath, uncPathPrev);
				}
			} else if (prevFile == mainFile && currFile != mainFile) {
				//assignment from the mainFile overwritten by an include
				warn_reassignment(loc, assignment, mainFilePath, uncPathPrev);
			}
			assignment->setExpr(std::shared_ptr<Expression>(expr));
			assignment->setLocationOfOverwrite(loc);
			found = true;
			break;
		}
	}
	if (!found) {
		scope_stack.top()->addAssignment(assignment(token, std::shared_ptr<Expression>(expr), loc));
	}
}

bool parse(SourceFile *&file, const std::string& text, const std::string &filename, const std::string &mainFile, int debug)
{
  fs::path filepath;
  try {
    filepath = filename.empty() ? fs::current_path() : fs::absolute(fs::path{filename});
    mainFilePath = mainFile.empty() ? fs::current_path() : fs::absolute(fs::path{mainFile});
  } catch (...) {
    // yyerror tries to print the file path, which throws again, and we can't do that
    LOG(message_group::Error, "Parser error: file access denied");
    return false;
  }

  parsingMainFile = mainFilePath == filepath;
  fs::path parser_sourcefile = fs::path(filepath).generic_string();
  lexer_set_parser_sourcefile(parser_sourcefile);

  lexerin = NULL;
  parser_error_pos = -1;
  parser_input_buffer = text.c_str();
  fileEnded = false;

  rootfile = new SourceFile(parser_sourcefile.parent_path().string(), parser_sourcefile.filename().string());
  scope_stack.push(&rootfile->scope);
  //        PRINTB_NOCACHE("New module: %s %p", "root" % rootfile);

  parserdebug = debug;
  int parserretval = -1;
  try{
     parserretval = parserparse();
  }catch (const HardWarningException &e) {
    yyerror("stop on first warning");
  }

  lexerdestroy();
  lexerlex_destroy();

  file = rootfile;
  if (parserretval != 0) return false;

  parser_error_pos = -1;
  parser_input_buffer = nullptr;
  scope_stack.pop();

  return true;
}
